SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 20:54'!
assertThat: aBlock produces: anErrorType andAfterwards: finalAssertions
	
	[ aBlock value.
	 self fail]
		on: anErrorType
		do: finalAssertions ! !

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 21:45'!
assertThat: aBlock takesLessMillisecondsThan: bound
	"executes a block and asserts that the execution took less than the specified amount of milliseconds"

	self assert: (Time millisecondsToRun: aBlock) < bound.
! !

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 20:08'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	| customerBook |
	
	customerBook := CustomerBook  new.
	
	self assertThat: [ customerBook addCustomerNamed: 'John Lennon' ] takesLessMillisecondsThan: 50! !

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 20:10'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	  
	self assertThat: [ customerBook removeCustomerNamed: johnLennon. ] takesLessMillisecondsThan: 100! !

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 20:52'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.

	self assertThat: [ customerBook addCustomerNamed: ''. ]
		 produces: Error
		 andAfterwards: 
			[ :anError | self assert: anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.
							self assert: customerBook isEmpty. ].! !

!IdiomTest methodsFor: 'testing' stamp: 'JuanEdi 4/22/2013 20:52'!
test04CanNotRemoveAndInvalidCustomer
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	
	self assertThat: [ customerBook removeCustomerNamed: 'Paul McCartney'. ]
		 produces: NotFound
		 andAfterwards:
			[ :anError | self assert: customerBook numberOfCustomers = 1. 
							self assert: (customerBook includesCustomerNamed: johnLennon)].
	! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
